<template>
  <div class="registration section">
    <h1>
      Бақайдгирии <br />
      <span>корбари (истифодабарандаи) нав</span>
    </h1>
    <client-only>
      <form v-if="!access" @submit.prevent="signUp()">
        <div class="registration-avatar">
          <img
            v-if="avatarURL || form.avatar"
            :src="avatarURL || form.avatar"
          />
          <img
            v-else
            src="https://www.pngitem.com/pimgs/m/198-1985222_avatar-doctor-png-transparent-png.png"
            @click="$refs.avatarInput.click()"
          />
          <input
            type="file"
            accept=".png,image/png,.jpg,image/jpg,.jpeg,image/jpeg"
            @change="inputAvatar"
            class="upload-input"
            ref="avatarInput"
            required
          />
          <button
            type="button"
            @click="$refs.avatarInput.click()"
            class="form-btn"
            v-html="avatarURL ? 'Таъғири сурат' : 'Иловаи сурат'"
          ></button>
        </div>
        <div class="registration-form">
          <div>
            <span>Ному насаб пура</span>
            <Input
              class="registration-item"
              placeholder="Рахимов Камол Самеевич"
              v-model="form.name"
              required
            />
          </div>

          <div>
            <span>Телефон</span>
            <Input
              class="registration-item"
              v-model="form.phone"
              required
              mask="phone"
              placeholder="+992 (000) 00-00-00"
            />
          </div>

          <div>
            <span>Вилоят</span>
            <Select
              single
              class="registration-item"
              :data="regions_list"
              v-model="form.region"
              required
            />
          </div>

          <div>
            <span>Ихтисос</span>
            <Select
              :key="is_specializations_list_changed"
              single
              class="registration-item"
              :data="specializations_list"
              v-model="form.specialization"
              required
            />
          </div>

          <div>
            <span>Ҷои кор:</span>
            <Input
              class="account-item"
              placeholder="Караболо"
              v-model="form.workplace"
              required
            />
          </div>

          <div>
            <span>Таҷрибаи корӣ</span>
            <Input
              class="account-item"
              v-model="form.experience"
              mask="bday"
              required
              placeholder="01.01.2023"
            />
          </div>

          <div
            v-if="
              form.specialization == 'Тибби оилавӣ' ||
              form.specialization == 'Ҳамшира/бародари тибби оилавӣ'
            "
          >
            <span>Дараҷанокии тахассусии тибби оилавиӣ</span>
            <Select
              single
              class="registration-item"
              :data="family_doctor_category_list"
              v-model="form.family_doctor_category"
              required
            />
          </div>

          <div
            v-if="
              form.family_doctor_category &&
              form.family_doctor_category !== 'Дараҷаиноки нест'
            "
          >
            <span>
              Соли гирифтани "{{ form.family_doctor_category }}" дар тибби
              оилавӣ
            </span>
            <Input
              class="account-item"
              v-model="form.family_doctor_category_year"
              required
              mask="bday"
              placeholder="01.01.2023"
            />
          </div>

          <div>
            <span>Маълумот</span>
            <Input
              class="account-item"
              placeholder="ТГМУ"
              v-model="form.education"
              required
            />
          </div>

          <div>
            <span>Санаи таваллуд</span>
            <Input
              class="account-item"
              v-model="form.birthday"
              mask="bday"
              required
              placeholder="01.01.2023"
            />
          </div>
        </div>
        <div class="registration-agree">
          <label class="checkbox">
            <input type="checkbox" name="agree" v-model="agree" required />
            <span>
              Ман
              <a
                href="https://storage.yandexcloud.net/nmoms/portal_docs/politika.pdf"
                target="_blank"
              >
                Сиёсати махфият
              </a>
              ва
              <a
                href="https://storage.yandexcloud.net/nmoms/portal_docs/oferta_nmoms.doc"
                target="_blank"
              >
                Созишномаи пешниҳодро
              </a>
              хондам ва коркарди
              <a
                href="https://storage.yandexcloud.net/nmoms/portal_docs/soglasie.pdf"
                target="_blank"
              >
                Маълумоти шахсӣ
              </a>
              розӣ ҳастам
            </span>
          </label>
        </div>
        <div class="registration-buttons">
          <button class="curve-btn" type="submit">
            <div>Ба қайд гиред</div>
          </button>
          <nuxt-link to="/" class="curve-btn back-link">
            <div>Баргаштан</div>
          </nuxt-link>
        </div>
      </form>

      <form v-else @submit.prevent="logIn()">
        <div class="registration-form">
          <div>
            <span>
              Рамзи тавассути sms омадаро <br />
              қайд намоед {{ form.phone }}
            </span>
            <Input class="registration-item" v-model="code" required />
          </div>
        </div>
        <div class="registration-buttons">
          <button type="submit" class="curve-btn">
            <div>Даромад</div>
          </button>
          <button @click="code = ''" class="curve-btn back-link">
            <div>Баргаштан</div>
          </button>
        </div>
      </form>
    </client-only>
    <div class="registration-footer">
      Аллакай ба қайд гирифтаед?
      <login>
        <span> Воридшавӣ </span>
      </login>
    </div>
  </div>
</template>

<script>
const REGIONS = [
  "Душанбе",
  "Вилояти Суғд",
  "Вилояти Хатлон",
  "Минтақаҳои тобеи ҷумҳурӣ",
  "Вилояти Мухтори Кӯҳистони Бадахшон",
];
const FAMILY_DOCTOR_CATEGORIES = [
  "Дараҷаи якум",
  "Дараҷаи дуюм",
  "Дараҷаи олӣ",
  "Дараҷаиноки нест",
];
export default {
  data() {
    return {
      form: {
        name: "",
        phone: "",
        region: "",
        specialization: "",
        workplace: "",
        education: "",
        birthday: "",
        experience: "",
        family_doctor_category: "",
        family_doctor_category_year: "",
        avatar: "",
        access: true,
      },

      specializations_list: [],
      regions_list: REGIONS,
      family_doctor_category_list: FAMILY_DOCTOR_CATEGORIES,

      agree: false,
      code: "",
      access: false,
      avatarURL: null,
      avatarImage: null,

      is_specializations_list_changed: 1,
    };
  },
  mounted() {
    this.specializationsData();
  },
  methods: {
    async signUp() {
      this.uploadImage()
        .then(() => {
          this.isNulledFamilyCategory()
            .then(() => {
              if (this.form.specialization === "Омӯзгор") {
                this.form.access = false;
              }
              this.$axios
                .$post(`/auth/signup`, this.form)
                .then(() => {
                  this.access = true;
                  document.querySelector("body").scrollTo(0, 0);
                })
                .catch((err) => {
                  if (err.response.data.message == "Duplicate phone entered") {
                    alert("Корбаре бо ин рақами телефон аллакай вуҷуд дорад!");
                  }
                  if (err.response.data.message == "No access") {
                    alert(
                      "Мунтазир бошед, то ки администратор (маъмур) ба шумо барои дастрасӣ ба система иҷозат диҳад!"
                    );
                    this.$router.push("/");
                  }
                });
            })
            .catch((err) => {
              console.log(err);
            });
        })
        .catch((err) => {
          alert(err);
        });
    },

    async logIn() {
      try {
        let data = { phone: this.form.phone, code: this.code };
        await this.$auth.loginWith("local", { data: data });
        this.$router.push("/profile/account");
      } catch (error) {
        if (err.response.data.message == "Invalid code") {
          alert("Вы ввели не верный код!");
        }
      }
    },

    async isNulledFamilyCategory() {
      if (this.form.specialization === "Омӯзгор") {
        this.form.family_doctor_category = "";
        this.form.family_doctor_category_year = "";
      }
      return true;
    },
    async uploadImage() {
      const avatarName =
        this.form.name +
        this.form.phone +
        "." +
        this.avatarImage.type.split("/").pop().trim();
      const formData = new FormData();
      formData.append("avatar", this.avatarImage, avatarName);
      const url = this.$config.UPLOADS_BACKEND_URL + "/uploadAvatar";
      try {
        let response = await this.$axios.$post(url, formData, {
          headers: {
            "content-type": "multipart/form-data",
          },
        });
        if (response.answer === "ok") {
          this.form.avatar = "/avatars/" + avatarName;
        }
      } catch (err) {
        throw new Error("uploadImage error", err);
      }
    },

    inputAvatar(e) {
      const avatar = e.target.files[0];
      if (avatar === undefined) {
        return;
      }
      if (avatar.size > 524288) {
        alert("Размер изображения не должен превышать 500 килобайт");
      } else {
        const reader = new FileReader();
        reader.readAsDataURL(avatar);
        reader.onload = (onloadEvent) => {
          this.avatarURL = onloadEvent.target.result;
          this.avatarImage = avatar;
        };
      }
    },

    async specializationsData() {
      this.$axios
        .$get(`/profile/specializationsData`)
        .then((response) => {
          this.specializations_list = response;
          this.is_specializations_list_changed++;
          console.log(this.specializations_list);
        })
        .catch((err) => {});
    },
  },
};
</script>

<style lang="scss" scoped>
.registration {
  min-height: 60vh;
  margin-top: 40px;
  h1 {
    line-height: 1;
    font-size: 48px;
    @include less-than(tablet) {
      font-size: 28px;
    }

    span {
      font-size: 38px;
      @include less-than(tablet) {
        font-size: 18px;
      }
    }
  }
  &-avatar {
    margin-top: 40px;
    display: flex;
    align-items: center;
    position: relative;
    @include less-than(tablet) {
      margin-top: 20px;
      margin-left: 10px;
      justify-content: center;
      flex-wrap: wrap;
      flex-direction: column;
    }
    input {
      width: 40px;
      height: 5px;
      position: absolute;
      left: 53px;
      @include less-than(tablet) {
        top: 40px;
        left: 47%;
      }
    }
    img {
      width: 120px;
      height: 120px;
      border: 1px solid #ccc;
      // border-radius: 100%;
      object-fit: cover;
    }
    button {
      margin-left: 40px;
      transition: all ease 0.3s;
      @include less-than(tablet) {
        margin-left: 0px;
        margin-top: 15px;
      }
      &:hover {
        color: #0c63e4;
      }
    }
  }
  &-form {
    margin-top: 40px;
    display: grid;
    grid-template-columns: repeat(3, 1fr);
    text-align: left;
    grid-gap: 40px;
    @include less-than(tablet) {
      grid-template-columns: repeat(1, 1fr);
      grid-gap: 20px;
    }
    span {
      display: block;
      margin-bottom: 5px;
    }
  }
  &-agree {
    margin-top: 40px;
    line-height: 1.5;
    cursor: pointer;
    font-size: 14px;
    label {
      cursor: pointer;
    }
    a {
      font-family: "Montserrat-Regular";
      border-bottom: 1px dashed #000;
      transition: all ease 0.3s;
      &:hover {
        color: #0c63e4;
        border-color: #0c63e4;
      }
    }
  }

  &-buttons {
    display: flex;
    margin-top: 40px;
    .back-link {
      background: #fff;
      color: #000;
    }
  }
  &-footer {
    display: flex;
    margin-top: 40px;
    span {
      font-family: "Montserrat-Regular";
      border-bottom: 1px dashed #000;
      transition: all ease 0.3s;
      cursor: pointer;
      margin-left: 10px;
      &:hover {
        color: #0c63e4;
        border-color: #0c63e4;
      }
    }
  }
}
</style>
